#
# Tabellenstruktur fuer Tabelle `content`
#
# Erzeugt am: 22. Januar 2006 um 22:27
# Aktualisiert am: 22. Januar 2006 um 22:27
#

CREATE TABLE `content` (
  `id` int(11) NOT NULL auto_increment,
  `title` varchar(255) default NULL,
  `belongs_to` int(11) NOT NULL default '0',
  `content` mediumtext NOT NULL,
  `type` varchar(255) NOT NULL default 'text',
  `sorting` int(11) NOT NULL default '0',
  `owner` int(11) NOT NULL default '0',
  `lastupdatedby` int(11) NOT NULL default '0',
  `lastupdated` timestamp NOT NULL,
  `group` int(11) NOT NULL default '0',
  `userrights` int(11) NOT NULL default '0',
  `grouprights` int(11) NOT NULL default '0',
  `otherrights` int(11) NOT NULL default '0',
  `deleted` int(1) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM AUTO_INCREMENT=1 ;

CREATE TABLE `content_open` (
  `id` int(11) NOT NULL auto_increment,
  `contentid` int(11) NOT NULL default '0',
  `userid`varchar(32) NOT NULL default '',
  `opened` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM AUTO_INCREMENT=1 ;

#
# Daten fr Tabelle `content`
#

# --------------------------------------------------------

#
# Tabellenstruktur fr Tabelle `files`
#
# Erzeugt am: 22. Januar 2006 um 22:27
# Aktualisiert am: 22. Januar 2006 um 22:27
#

CREATE TABLE `files` (
  `id` int(11) NOT NULL auto_increment,
  `belongs_to` int(11) default NULL,
  `file` longblob,
  `filename` varchar(255) default NULL,
  `filesize` int(11) default NULL,
  `filetype` varchar(255) default 'application/octet-stream',
  `owner` int(11) NOT NULL default '0',
  `date` timestamp NOT NULL,
  `deleted` int(1) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM AUTO_INCREMENT=1 ;

#
# Daten fr Tabelle `files`
#

# --------------------------------------------------------

#
# Tabellenstruktur fr Tabelle `groups`
#
# Erzeugt am: 22. Januar 2006 um 21:43
# Aktualisiert am: 22. Januar 2006 um 22:28
#

CREATE TABLE `groups` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(255) NOT NULL default '',
  `enabled` int(1) NOT NULL default '0',
  `deleted` int(1) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM AUTO_INCREMENT=1 ;

#
# Daten fr Tabelle `groups`
#


# --------------------------------------------------------

#
# Tabellenstruktur fr Tabelle `tree`
#
# Erzeugt am: 22. Januar 2006 um 22:27
# Aktualisiert am: 22. Januar 2006 um 22:27
#

CREATE TABLE `tree` (
  `id` int(11) NOT NULL auto_increment,
  `belongs_to` int(11) NOT NULL default '0',
  `title` varchar(255) NOT NULL default '',
  `alias` varchar(255) NOT NULL default '',
  `contentcollapsed` int(1) NOT NULL default '0',
  `owner` int(11) NOT NULL default '0',
  `group` int(11) NOT NULL default '0',
  `userrights` int(11) NOT NULL default '0',
  `grouprights` int(11) NOT NULL default '0',
  `otherrights` int(11) NOT NULL default '0',
  `deleted` int(1) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM AUTO_INCREMENT=1 ;

#
# Daten fr Tabelle `tree`
#

# --------------------------------------------------------

#
# Tabellenstruktur fr Tabelle `user_group`
#
# Erzeugt am: 22. Januar 2006 um 21:43
# Aktualisiert am: 22. Januar 2006 um 21:54
#

CREATE TABLE `user_group` (
  `id` int(11) NOT NULL auto_increment,
  `userid` int(11) NOT NULL default '0',
  `groupid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM AUTO_INCREMENT=1 ;

#
# Daten fr Tabelle `user_group`
#


# --------------------------------------------------------

#
# Tabellenstruktur fr Tabelle `users`
#
# Erzeugt am: 22. Januar 2006 um 21:41
# Aktualisiert am: 22. Januar 2006 um 22:28
#

CREATE TABLE `users` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(255) NOT NULL default '',
  `password` varchar(32) NOT NULL default '',
  `theme` varchar(255) NOT NULL default '',
  `language` varchar(255) NOT NULL default '',
  `enabled` int(1) NOT NULL default '0',
  `defaultgroup` int(11) NOT NULL default '0',
  `defaultrights` int(3) NOT NULL default '0',
  `admin` int(1) NOT NULL default '0',
  `rightedit` int(1) NOT NULL default '0',
  `treecache` text NOT NULL,
  `deleted` int(1) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM AUTO_INCREMENT=3 ;

#
# Daten fr Tabelle `users`
#

# --------------------------------------------------------

CREATE TABLE `history` (
  `id` int(11) NOT NULL auto_increment,
  `contentid` int(11) NOT NULL,
  `version` int(11) NOT NULL,
  `title` varchar(255) default NULL,
  `content` mediumtext NOT NULL,
  `type` varchar(255) NOT NULL default 'text',
  `lastupdatedby` int(11) NOT NULL default '0',
  `lastupdated` timestamp NOT NULL,
  PRIMARY KEY  (`id`)
) TYPE=MyISAM AUTO_INCREMENT=1 ;

#
# Daten fr Tabelle `history`
#

CREATE TABLE `extensions` (
`id` INT NOT NULL AUTO_INCREMENT ,
`keyname` VARCHAR( 255 ) NOT NULL ,
`active` INT NOT NULL ,
`admin` INT NOT NULL DEFAULT '0',
`version` VARCHAR(30) NOT NULL DEFAULT '',
PRIMARY KEY ( `id` )
);

CREATE TABLE `settings` (
`id` INT NOT NULL AUTO_INCREMENT ,
`name` VARCHAR( 255 ) NOT NULL ,
`value` VARCHAR( 255 ) NOT NULL ,
PRIMARY KEY ( `id` ) ,
UNIQUE (
`name`
)
);


INSERT INTO `users` ( `id` , `name` , `password` , `enabled` , `defaultgroup` , `defaultrights` , `admin` , `rightedit` , `treecache` )
VALUES (
'1', 'admin', '21232f297a57a5a743894a0e4a801fc3', '1', '1', '210', '1', '1', ''
);

INSERT INTO `groups` ( `id` , `name` , `enabled` )
VALUES (
'1', 'admin', '1'
);

INSERT INTO `groups` ( `id` , `name` , `enabled` )
VALUES (
'2', 'users', '1'
);

# Enable extensions
INSERT INTO `extensions` (`keyname`, `active`, `admin`) VALUES ('admin_extension', 1, 1);
INSERT INTO `extensions` (`keyname`, `active`, `admin`) VALUES ('admin_info', 1, 1);
INSERT INTO `extensions` (`keyname`, `active`, `admin`) VALUES ('admin_install', 1, 1);
INSERT INTO `extensions` (`keyname`, `active`, `admin`) VALUES ('admin_update', 1, 1);
INSERT INTO `extensions` (`keyname`, `active`, `admin`) VALUES ('admin_config', 1, 1);



CREATE TABLE `users_login` (
  `usersid` int(10) unsigned NOT NULL default '0',
  `login_trial` int(10) unsigned NOT NULL default '0',
  `lasttrydate` int(11) unsigned NOT NULL default '0',
  `session_id` varchar(100) NOT NULL default '',
  UNIQUE KEY `usersid` (`usersid`)
);

# insert default settings
INSERT INTO `settings` (`name`, `value`) VALUES ('login.delay', '30');
INSERT INTO `settings` (`name`, `value`) VALUES ('login.max', '50');
INSERT INTO `settings` (`name`, `value`) VALUES ('knowledgeroot.charset', 'UTF-8');
INSERT INTO `settings` (`name`, `value`) VALUES ('knowledgeroot.language', 'en');
INSERT INTO `settings` (`name`, `value`) VALUES ('knowledgeroot.language_dropdown', '0');
INSERT INTO `settings` (`name`, `value`) VALUES ('knowledgeroot.availablelanguages.1', 'en');
INSERT INTO `settings` (`name`, `value`) VALUES ('knowledgeroot.availablelanguages.2', 'de');
INSERT INTO `settings` (`name`, `value`) VALUES ('knowledgeroot.availablelanguages.3', 'pt-br');
INSERT INTO `settings` (`name`, `value`) VALUES ('knowledgeroot.availablelanguages.4', 'nl');
INSERT INTO `settings` (`name`, `value`) VALUES ('knowledgeroot.availablelanguages.5', 'ja');
INSERT INTO `settings` (`name`, `value`) VALUES ('knowledgeroot.availablelanguages.5', 'es');
INSERT INTO `settings` (`name`, `value`) VALUES ('htmleditor.use', '1');
INSERT INTO `settings` (`name`, `value`) VALUES ('htmleditor.editor', 'fckeditor');
INSERT INTO `settings` (`name`, `value`) VALUES ('htmleditor.tinymce.cols', '75');
INSERT INTO `settings` (`name`, `value`) VALUES ('htmleditor.tinymce.rows', '20');
INSERT INTO `settings` (`name`, `value`) VALUES ('htmleditor.fckeditor.width', '600');
INSERT INTO `settings` (`name`, `value`) VALUES ('htmleditor.fckeditor.height', '450');
INSERT INTO `settings` (`name`, `value`) VALUES ('htmleditor.fckeditor.langdefault', 'en');
INSERT INTO `settings` (`name`, `value`) VALUES ('htmleditor.fckeditor.langdetect', 'false');
INSERT INTO `settings` (`name`, `value`) VALUES ('htmleditor.fckeditor.toolbar', 'Default');
INSERT INTO `settings` (`name`, `value`) VALUES ('htmleditor.fckeditor.skin', 'default');
INSERT INTO `settings` (`name`, `value`) VALUES ('knowledgeroot.title', 'Knowledgeroot');
INSERT INTO `settings` (`name`, `value`) VALUES ('menu.expandall', '1');
INSERT INTO `settings` (`name`, `value`) VALUES ('menu.type', 'static');
INSERT INTO `settings` (`name`, `value`) VALUES ('menu.ajax', 'yes');
INSERT INTO `settings` (`name`, `value`) VALUES ('knowledgeroot.default_theme', 'green');
INSERT INTO `settings` (`name`, `value`) VALUES ('knowledgeroot.showtitle', 'yes');
INSERT INTO `settings` (`name`, `value`) VALUES ('knowledgeroot.collapsecontent', 'yes');
INSERT INTO `settings` (`name`, `value`) VALUES ('knowledgeroot.showlastupdated', 'yes');
INSERT INTO `settings` (`name`, `value`) VALUES ('knowledgeroot.uploadfolder', 'uploads/');
INSERT INTO `settings` (`name`, `value`) VALUES ('knowledgeroot.uploadserverpath', 'auto');
INSERT INTO `settings` (`name`, `value`) VALUES ('knowledgeroot.defaultpage', '');
INSERT INTO `settings` (`name`, `value`) VALUES ('email.notification', '0');
INSERT INTO `settings` (`name`, `value`) VALUES ('email.recipients', '');
INSERT INTO `settings` (`name`, `value`) VALUES ('email.type', 'html');
INSERT INTO `settings` (`name`, `value`) VALUES ('email.from_name', 'Knowledgeroot');
INSERT INTO `settings` (`name`, `value`) VALUES ('email.from_email', 'knowledgeroot@mydomain.tld');
INSERT INTO `settings` (`name`, `value`) VALUES ('email.smtp_mode', '0');
INSERT INTO `settings` (`name`, `value`) VALUES ('email.smtp_host', '');
INSERT INTO `settings` (`name`, `value`) VALUES ('email.smtp_port', '25');
INSERT INTO `settings` (`name`, `value`) VALUES ('email.smtp_username', '');
INSERT INTO `settings` (`name`, `value`) VALUES ('email.smtp_password', '');
INSERT INTO `settings` (`name`, `value`) VALUES ('dev.toolbar', '0');
INSERT INTO `settings` (`name`, `value`) VALUES ('pagealias.use', '1');
INSERT INTO `settings` (`name`, `value`) VALUES ('pagealias.rights', '2');
INSERT INTO `settings` (`name`, `value`) VALUES ('pagealias.static', '0');