ALTER TABLE `content` ADD `type` varchar(255) DEFAULT 'text' NOT NULL;
ALTER TABLE `content` ADD `title` varchar(255) default NULL;
ALTER TABLE `content` ADD `lastupdatedby` int(11) NOT NULL default '0';
ALTER TABLE `content` ADD `lastupdated` timestamp(14) NOT NULL default '';
ALTER TABLE `tree` ADD `alias` varchar(255) DEFAULT '' NOT NULL;
ALTER TABLE `tree` ADD `contentcollapsed` int(1) NOT NULL DEFAULT '0';
ALTER TABLE `content` CHANGE `content` `content` MEDIUMTEXT NOT NULL;
ALTER TABLE `users` CHANGE `password` `password` VARCHAR(32) NOT NULL;

CREATE TABLE `extensions` (
`id` INT NOT NULL AUTO_INCREMENT ,
`keyname` VARCHAR( 255 ) NOT NULL ,
`active` INT NOT NULL ,
`admin` INT NOT NULL DEFAULT '0',
`version` VARCHAR(30) NOT NULL DEFAULT '',
PRIMARY KEY ( `id` )
);

CREATE TABLE `settings` (
`id` INT NOT NULL AUTO_INCREMENT ,
`name` VARCHAR( 255 ) NOT NULL ,
`value` VARCHAR( 255 ) NOT NULL ,
PRIMARY KEY ( `id` ) ,
UNIQUE (
`name`
)
);

CREATE TABLE `content_open` (
	`id` int(11) NOT NULL auto_increment,
	`contentid` int(11) NOT NULL default '0',
	`userid`varchar(32) NOT NULL default '',
	`opened` int(11) NOT NULL default '0',
	PRIMARY KEY  (`id`)
) TYPE=MyISAM AUTO_INCREMENT=1 ;

CREATE TABLE `users_login` (
  `usersid` int(10) unsigned NOT NULL default '0',
  `login_trial` int(10) unsigned NOT NULL default '0',
  `lasttrydate` int(11) unsigned NOT NULL default '0',
  `session_id` varchar(100) NOT NULL default '',
  UNIQUE KEY `usersid` (`usersid`)
);

# Enable extensions
INSERT INTO `extensions` (`keyname`, `active`, `admin`) VALUES ('admin_extension', 1, 1);
INSERT INTO `extensions` (`keyname`, `active`, `admin`) VALUES ('admin_info', 1, 1);
INSERT INTO `extensions` (`keyname`, `active`, `admin`) VALUES ('admin_install', 1, 1);
INSERT INTO `extensions` (`keyname`, `active`, `admin`) VALUES ('admin_update', 1, 1);
INSERT INTO `extensions` (`keyname`, `active`, `admin`) VALUES ('admin_config', 1, 1);

# insert default settings
INSERT INTO `settings` (`name`, `value`) VALUES ('login.delay', '30');
INSERT INTO `settings` (`name`, `value`) VALUES ('login.max', '50');
INSERT INTO `settings` (`name`, `value`) VALUES ('knowledgeroot.charset', 'UTF-8');
INSERT INTO `settings` (`name`, `value`) VALUES ('knowledgeroot.language', 'en');
INSERT INTO `settings` (`name`, `value`) VALUES ('knowledgeroot.language_dropdown', '0');
INSERT INTO `settings` (`name`, `value`) VALUES ('knowledgeroot.availablelanguages.1', 'en');
INSERT INTO `settings` (`name`, `value`) VALUES ('knowledgeroot.availablelanguages.2', 'de');
INSERT INTO `settings` (`name`, `value`) VALUES ('knowledgeroot.availablelanguages.3', 'pt-br');
INSERT INTO `settings` (`name`, `value`) VALUES ('knowledgeroot.availablelanguages.4', 'nl');
INSERT INTO `settings` (`name`, `value`) VALUES ('knowledgeroot.availablelanguages.5', 'ja');
INSERT INTO `settings` (`name`, `value`) VALUES ('knowledgeroot.availablelanguages.5', 'es');
INSERT INTO `settings` (`name`, `value`) VALUES ('htmleditor.use', '1');
INSERT INTO `settings` (`name`, `value`) VALUES ('htmleditor.editor', 'fckeditor');
INSERT INTO `settings` (`name`, `value`) VALUES ('htmleditor.tinymce.cols', '75');
INSERT INTO `settings` (`name`, `value`) VALUES ('htmleditor.tinymce.rows', '20');
INSERT INTO `settings` (`name`, `value`) VALUES ('htmleditor.fckeditor.width', '600');
INSERT INTO `settings` (`name`, `value`) VALUES ('htmleditor.fckeditor.height', '450');
INSERT INTO `settings` (`name`, `value`) VALUES ('htmleditor.fckeditor.langdefault', 'en');
INSERT INTO `settings` (`name`, `value`) VALUES ('htmleditor.fckeditor.langdetect', 'false');
INSERT INTO `settings` (`name`, `value`) VALUES ('htmleditor.fckeditor.toolbar', 'Default');
INSERT INTO `settings` (`name`, `value`) VALUES ('htmleditor.fckeditor.skin', 'default');
INSERT INTO `settings` (`name`, `value`) VALUES ('knowledgeroot.title', 'Knowledgeroot');
INSERT INTO `settings` (`name`, `value`) VALUES ('menu.expandall', '1');
INSERT INTO `settings` (`name`, `value`) VALUES ('menu.type', 'static');
INSERT INTO `settings` (`name`, `value`) VALUES ('menu.ajax', 'yes');
INSERT INTO `settings` (`name`, `value`) VALUES ('knowledgeroot.default_theme', 'green');
INSERT INTO `settings` (`name`, `value`) VALUES ('knowledgeroot.showtitle', 'yes');
INSERT INTO `settings` (`name`, `value`) VALUES ('knowledgeroot.collapsecontent', 'yes');
INSERT INTO `settings` (`name`, `value`) VALUES ('knowledgeroot.showlastupdated', 'yes');
INSERT INTO `settings` (`name`, `value`) VALUES ('knowledgeroot.uploadfolder', 'uploads/');
INSERT INTO `settings` (`name`, `value`) VALUES ('knowledgeroot.uploadserverpath', 'auto');
INSERT INTO `settings` (`name`, `value`) VALUES ('knowledgeroot.defaultpage', '');
INSERT INTO `settings` (`name`, `value`) VALUES ('email.notification', '0');
INSERT INTO `settings` (`name`, `value`) VALUES ('email.recipients', '');
INSERT INTO `settings` (`name`, `value`) VALUES ('email.type', 'html');
INSERT INTO `settings` (`name`, `value`) VALUES ('email.from_name', 'Knowledgeroot');
INSERT INTO `settings` (`name`, `value`) VALUES ('email.from_email', 'knowledgeroot@mydomain.tld');
INSERT INTO `settings` (`name`, `value`) VALUES ('email.smtp_mode', '0');
INSERT INTO `settings` (`name`, `value`) VALUES ('email.smtp_host', '');
INSERT INTO `settings` (`name`, `value`) VALUES ('email.smtp_port', '25');
INSERT INTO `settings` (`name`, `value`) VALUES ('email.smtp_username', '');
INSERT INTO `settings` (`name`, `value`) VALUES ('email.smtp_password', '');
INSERT INTO `settings` (`name`, `value`) VALUES ('dev.toolbar', '0');
INSERT INTO `settings` (`name`, `value`) VALUES ('pagealias.use', '1');
INSERT INTO `settings` (`name`, `value`) VALUES ('pagealias.rights', '2');
INSERT INTO `settings` (`name`, `value`) VALUES ('pagealias.static', '0');