BEGIN;

ALTER TABLE content ADD COLUMN type varchar(255);
ALTER TABLE content ALTER COLUMN type SET DEFAULT 'text';

ALTER TABLE content ADD COLUMN title varchar(255);
ALTER TABLE content ALTER COLUMN type SET DEFAULT 'text';

ALTER TABLE content ADD COLUMN lastupdated timestamp;
ALTER TABLE content ALTER COLUMN lastupdated SET DEFAULT now();

ALTER TABLE content ADD COLUMN lastupdatedby integer;
ALTER TABLE content ALTER COLUMN lastupdatedby SET DEFAULT 0;

ALTER TABLE tree ADD COLUMN alias varchar(255);
ALTER TABLE tree ALTER COLUMN alias SET DEFAULT '';

ALTER TABLE tree ADD COLUMN contentcollapsed integer;
ALTER TABLE tree ALTER COLUMN contentcollapsed SET DEFAULT 0;

ALTER TABLE users ADD COLUMN password2 varchar(32);
ALTER TABLE users ALTER COLUMN password2 SET DEFAULT '';
UPDATE users SET password2 = "password";
ALTER TABLE users DROP COLUMN "password";
ALTER TABLE users RENAME COLUMN password2 TO "password";

CREATE TABLE extensions (
	id integer PRIMARY KEY DEFAULT nextval('seq_knowledge'),
	keyname varchar(255) DEFAULT '',
	active integer DEFAULT 0,
	admin integer DEFAULT 0,
	version varchar(30) DEFAULT ''
);

CREATE TABLE settings (
	id integer PRIMARY KEY DEFAULT nextval('seq_knowledge'),
	name varchar(255) NOT NULL,
	value varchar(255) DEFAULT '',
	UNIQUE (name)
);

CREATE TABLE content_open (
	id integer PRIMARY KEY DEFAULT nextval('seq_knowledge'),
	contentid integer DEFAULT 0,
	userid varchar(32) DEFAULT '',
	opened integer DEFAULT 0
);

CREATE TABLE users_login (
  usersid integer default 0,
  login_trial integer default 0,
  lasttrydate integer default 0,
  session_id varchar(100) default '',
  UNIQUE (usersid)
);

INSERT INTO extensions (keyname, active, admin) VALUES ('admin_extension', 1, 1);
INSERT INTO extensions (keyname, active, admin) VALUES ('admin_info', 1, 1);
INSERT INTO extensions (keyname, active, admin) VALUES ('admin_install', 1, 1);
INSERT INTO extensions (keyname, active, admin) VALUES ('admin_update', 1, 1);
INSERT INTO extensions (keyname, active, admin) VALUES ('admin_config', 1, 1);

INSERT INTO settings (name, value) VALUES ('login.delay', '30');
INSERT INTO settings (name, value) VALUES ('login.max', '50');
INSERT INTO settings (name, value) VALUES ('knowledgeroot.charset', 'UTF-8');
INSERT INTO settings (name, value) VALUES ('knowledgeroot.language', 'en');
INSERT INTO settings (name, value) VALUES ('knowledgeroot.language_dropdown', '0');
INSERT INTO settings (name, value) VALUES ('knowledgeroot.availablelanguages.1', 'en');
INSERT INTO settings (name, value) VALUES ('knowledgeroot.availablelanguages.2', 'de');
INSERT INTO settings (name, value) VALUES ('knowledgeroot.availablelanguages.3', 'pt-br');
INSERT INTO settings (name, value) VALUES ('knowledgeroot.availablelanguages.4', 'nl');
INSERT INTO settings (name, value) VALUES ('knowledgeroot.availablelanguages.5', 'ja');
INSERT INTO settings (name, value) VALUES ('knowledgeroot.availablelanguages.5', 'es');
INSERT INTO settings (name, value) VALUES ('htmleditor.use', '1');
INSERT INTO settings (name, value) VALUES ('htmleditor.editor', 'fckeditor');
INSERT INTO settings (name, value) VALUES ('htmleditor.tinymce.cols', '75');
INSERT INTO settings (name, value) VALUES ('htmleditor.tinymce.rows', '20');
INSERT INTO settings (name, value) VALUES ('htmleditor.fckeditor.width', '600');
INSERT INTO settings (name, value) VALUES ('htmleditor.fckeditor.height', '450');
INSERT INTO settings (name, value) VALUES ('htmleditor.fckeditor.langdefault', 'en');
INSERT INTO settings (name, value) VALUES ('htmleditor.fckeditor.langdetect', 'false');
INSERT INTO settings (name, value) VALUES ('htmleditor.fckeditor.toolbar', 'Default');
INSERT INTO settings (name, value) VALUES ('htmleditor.fckeditor.skin', 'default');
INSERT INTO settings (name, value) VALUES ('knowledgeroot.title', 'Knowledgeroot');
INSERT INTO settings (name, value) VALUES ('menu.expandall', '1');
INSERT INTO settings (name, value) VALUES ('menu.type', 'static');
INSERT INTO settings (name, value) VALUES ('menu.ajax', 'yes');
INSERT INTO settings (name, value) VALUES ('knowledgeroot.default_theme', 'green');
INSERT INTO settings (name, value) VALUES ('knowledgeroot.showtitle', 'yes');
INSERT INTO settings (name, value) VALUES ('knowledgeroot.collapsecontent', 'yes');
INSERT INTO settings (name, value) VALUES ('knowledgeroot.showlastupdated', 'yes');
INSERT INTO settings (name, value) VALUES ('knowledgeroot.uploadfolder', 'uploads/');
INSERT INTO settings (name, value) VALUES ('knowledgeroot.uploadserverpath', 'auto');
INSERT INTO settings (name, value) VALUES ('knowledgeroot.defaultpage', '');
INSERT INTO settings (name, value) VALUES ('email.notification', '0');
INSERT INTO settings (name, value) VALUES ('email.recipients', '');
INSERT INTO settings (name, value) VALUES ('email.type', 'html');
INSERT INTO settings (name, value) VALUES ('email.from_name', 'Knowledgeroot');
INSERT INTO settings (name, value) VALUES ('email.from_email', 'knowledgeroot@mydomain.tld');
INSERT INTO settings (name, value) VALUES ('email.smtp_mode', '0');
INSERT INTO settings (name, value) VALUES ('email.smtp_host', '');
INSERT INTO settings (name, value) VALUES ('email.smtp_port', '25');
INSERT INTO settings (name, value) VALUES ('email.smtp_username', '');
INSERT INTO settings (name, value) VALUES ('email.smtp_password', '');
INSERT INTO settings (name, value) VALUES ('dev.toolbar', '0');
INSERT INTO settings (name, value) VALUES ('pagealias.use', '1');
INSERT INTO settings (name, value) VALUES ('pagealias.rights', '2');
INSERT INTO settings (name, value) VALUES ('pagealias.static', '0');

COMMIT;