<?php
/**
 * This Class to show history of contents
 *
 * @package Knowledgeroot
 * @author Frank Habermann
 * @version $Id: class-history.php 147 2006-10-26 22:12:45Z koala_s $
 */
class history extends extension_base {

	var $menu = array();
	
	var $enable_email_notify = false;
	var $diff_text = "";
	var $old_record = array();
	var $content_version = 1;

	function main() {
		$content = "";

		// add menu item to top navi
		$this->menu['content']['contenthistory']['name'] = $this->CLASS['language']->get['contenthistory'];
		$this->menu['content']['contenthistory']['link'] = "index.php?action=contenthistory&historyof=";
		$this->menu['content']['contenthistory']['addid'] = "1";
		$this->menu['content']['contenthistory']['priority'] = "35";
		$this->menu['content']['contenthistory']['contenttype'] = "text";

		// set hooks
		$this->CLASS['hooks']->execAtHook("kr_header","edit_content","start","history","edit_content_header");
		$this->CLASS['hooks']->execAtHook("kr_header","edit_content","end","history","edit_content_header_end");
		$this->CLASS['hooks']->execAtHook("kr_content","edit_content","show","history","edit_content");
		
		if(isset ($_GET['action']) and $_GET['action'] == "contenthistory") {
			$content = $this->content_history();
		}
		
		return $content;
	}
	
	/**
	 * do this in the header if content was edited
	 */
	function edit_content_header() {
		// grab old version
		$res = $this->CLASS['db']->query("SELECT max(version) AS version FROM kx_ext_history WHERE contentid='".$_POST['editid']."'");
		$anz = $this->CLASS['db']->num_rows($res);
		
		if($anz == 1) {
			$row = $this->CLASS['db']->fetch_assoc($res);
			$newversion = $row['version'] + 1;
			$this->content_Version = $row['version'];
		} else {
			$newversion = 1;
		}
		
		$res = $this->CLASS['db']->query("SELECT * FROM content WHERE id='".$_POST['editid']."'");
		$anz = $this->CLASS['db']->num_rows($res);
		
		if($anz == 1) {
			// get old version
			$row = $this->CLASS['db']->fetch_assoc($res);
			
			// save new version to history
			$res = $this->CLASS['db']->query("INSERT into kx_ext_history (contentid, version, content, title, type, lastupdatedby, lastupdated) VALUES(".$row['id'].", ".$newversion.", '".addslashes($row['content'])."', '".addslashes($row['title'])."', '".$row['type']."', ".$row['lastupdatedby'].", '".$row['lastupdated']."')");		
		
			if (!isset ($_POST['minorchange']) or $_POST['minorchange'] == '') {
				$this->old_record =$row;
				$this->diff_text = $this->PHPDiff($row['content'], stripslashes($_POST['content']), $this->CLASS['notification']->html);
			}
		}
		
		// disable emailnotification for temporary
		if($this->CLASS['vars']['email']['notification'] == 1) {
			$this->CLASS['vars']['email']['notification'] = 0;
			$this->enable_email_notify = true;
		}
	}
	
	function edit_content_header_end() {
		if($this->enable_email_notify == true) {
			$this->CLASS['vars']['email']['notification'] = 1;
			$this->enable_email_notify = false;
		}
		
		if (!isset ($_POST['minorchange']) or $_POST['minorchange'] == "") {
			// set extra content for htmlmailheader
			$mailhead = '
				<style type="text/css"><!--
					h3 { font-family: verdana,arial,helvetica,sans-serif; font-size: 10pt; font-weight: bold; }
					#patch { width: 100%; }
					#patch h4 {font-family: verdana,arial,helvetica,sans-serif;font-size:10pt;padding:8px;background:#577;color:#fff;margin:0;}
					#patch .propset h4, #patch .binary h4 {margin:0;}
					#patch pre {padding:0;line-height:1.2em;margin:0;}
					#patch .diff {width:100%;background:#eee;padding: 0 0 10px 0;overflow:auto;}
					#patch span {display:block;padding:0 10px;}
					#patch .modfile, #patch .addfile, #patch .delfile, #patch .propset, #patch .binary, #patch .copfile {border:1px solid #ccc;margin:10px 0;}
					#patch ins {background:#dfd;text-decoration:none;display:block;padding:0 10px;}
					#patch del {background:#fdd;text-decoration:none;display:block;padding:0 10px;}
					#patch .lines, .info {color:#888;background:#fff;}
				--></style>
			';
			
			$this->CLASS['notification']->addMailHtmlHeader($mailhead);
			
			// set extra content for mailbody
			$extraMailBody = '
				<div id="patch">
				<h3>' . $this->CLASS['language']->get['ext']['history']['detailofchanges'] . ': </h3>
				<div class="modfile"><h4>' . $this->CLASS['language']->sys['searchcontent'] . ' ' . $this->CLASS['language']->get['ext']['history']['modified'] . ' :  (' . $this->CLASS['language']->sys['version'] . ' ' . $this->content_version . ' => ' . ($this->content_version+1)  . ')</h4>
				<pre class="diff"><span>' . $this->diff_text . ' </span></pre></div>
			';
			
			$pagename = $this->CLASS['path']->getTreePageTitle($_SESSION['cid']);
			$this->CLASS['notification']->send_email_notification($_SESSION['cid'],"content","edited",$pagename,$_POST['editid'], $extraMailBody);
		}
	}

	/**
	 * do this at content show if content was edited
	 */
	function edit_content() {
		if($this->CLASS['vars']['email']['notification'] == 1)
			echo "<br /><input type=\"checkbox\" name=\"minorchange\" >&nbsp;" . $this->CLASS['language']->get['ext']['history']['minorchange'] . "<br />";
	}
		
	/**
	 * show content history
	 */
	function content_history() {
		$out = "";
		$out .= "[<a href=\"index.php\">".$this->CLASS['language']->get['back']."</a>]<br />";

		// check if content rights allow reverting to previous version
		$canRevert = ($this->CLASS['knowledgeroot']->getContentRights($_GET['historyof'],$_SESSION['userid']) == 2);

		// get the actual version number
		$res = $this->CLASS['db']->query("SELECT max(version) AS version FROM kx_ext_history WHERE contentid='".$_GET['historyof']."'");
		$anz = $this->CLASS['db']->num_rows($res);
		
		if($anz == 1) {
			$row = $this->CLASS['db']->fetch_assoc($res);
			$actual_version = $row['version'] + 1;
		} else {
			$actual_version = 1;
		}
		
		// get the current version of the content
		if($this->CLASS['db']->dbtype == "pgsql") {
			$query = "SELECT ct.id as id, ct.content as content, ct.title as title, u.name as lastupdatedby, to_char(ct.lastupdated,'DD. Mon YYYY HH24:MI:SS') as lastupdated FROM content ct left outer join users u ON ct.lastupdatedby = u.id WHERE ct.id='".$_GET['historyof']."' AND ct.deleted=0";
		} else {
			$query = "SELECT ct.id as id, ct.content as content, ct.title as title, u.name as lastupdatedby, DATE_FORMAT(ct.lastupdated,'%d. %M %Y %H:%i:%s') as lastupdated FROM content ct left outer join users u ON ct.lastupdatedby = u.id WHERE ct.id='".$_GET['historyof']."' AND ct.deleted=0";
		}
		$res = $this->CLASS['db']->query($query);
		$anz = $this->CLASS['db']->num_rows($res);
		
		if($anz != 1) {
			return "";
		}
		
		$current = $this->CLASS['db']->fetch_assoc($res);
		
		// get the previous versions of the content
		if($this->CLASS['db']->dbtype == "pgsql") {
			$query = "SELECT hs.id as id, hs.content as content, hs.title as title, hs.version as version, u.name as lastupdatedby, to_char(hs.lastupdated,'DD. Mon YYYY HH24:MI:SS') as lastupdated FROM kx_ext_history hs left outer join users u ON hs.lastupdatedby = u.id WHERE hs.contentid='".$_GET['historyof']."' ORDER BY hs.version DESC";
		} else {
			$query = "SELECT hs.id as id, hs.content as content, hs.title as title, hs.version as version, u.name as lastupdatedby, DATE_FORMAT(hs.lastupdated,'%d. %M %Y %H:%i:%s') as lastupdated FROM kx_ext_history hs left outer join users u ON hs.lastupdatedby = u.id WHERE hs.contentid='".$_GET['historyof']."' ORDER BY hs.version DESC";
		}
		$res = $this->CLASS['db']->query($query);
		$historyCount = $this->CLASS['db']->num_rows($res);

		// show title
		$out .= '<h3>' . $this->CLASS['language']->get['ext']['history']['contenthistory'] . ($current['title'] != null ? " (" . $current['title'] . ")" : "") . '</h3>';


		$firstpass = true;
		$oldrecord = array();
		// show each history change record
		if($historyCount > 0) {
			while($historyrec = $this->CLASS['db']->fetch_assoc($res)) {
				if ($firstpass == true) {
					$newrecord = $current;
					$firstpass = false;
					
					$out .= $this->show_history_version($newrecord,$actual_version,$historyrec['content']);
				}
				
				
				if(!isset($oldrecord['content'])) $oldrecord['content'] = "";
				
				// Output history information
				$out .= $this->show_history_version($historyrec,$historyrec['version'],$oldrecord['content']);
					
				$oldrecord = $historyrec;
			}
		} else {
			$out .= $this->show_history_version($current,$actual_version,"");
		}

		return $out;
	}
	
	/**
	 * show detailed version
	 */
	function show_history_version($dbarr,$version,$diff) {
		$out = "";
		$out .= '
			<div id="patch"><div class="modfile"><dl>
				<dt>' . $this->CLASS['language']->get['ext']['history']['version'] . '</dt> <dd> ' . $version . '</dd>
				<dt>' . $this->CLASS['language']->get['ext']['history']['author'] . '</dt> <dd>' . (strlen($dbarr['lastupdatedby']) > 0 ? $dbarr['lastupdatedby'] : "guest") . '</dd>
				<dt>' . $this->CLASS['language']->get['ext']['history']['date'] . '</dt> <dd>' . $dbarr['lastupdated'] . '</dd>
				</dl><pre class="diff">' . "\n";
		$out .= $this->PHPDiff($diff, $dbarr['content'], true);
		$out .= '</pre></div></div>' . "\n";
		
		return $out;
	}
	
	/**
	 * PHPDiff function
	 *  Copyright 2003,2004 Nils Knappmeier (nk@knappi.org)
	 *  Copyright 2004-2005 Patrick R. Michaud (pmichaud@pobox.com)
	 *  Copyright 2006 Michael Fields (mfields1@gmail.com)
	 *
	 *  This code is part of Knowledgeroot; you can redistribute it and/or modify
	 *  it under the terms of the GNU General Public License as published
	 *  by the Free Software Foundation; either version 2 of the License, or
	 *  (at your option) any later version.
	 *
	 *  This file implements a diff function in native PHP.  It is based
	 *  on the PHPDiff code from pmWiki, which was based
	 *  upon the PHPDiffEngine code written by Nils Knappmeier, who in turn
	 *  had used Daniel Unterberger's diff
	 *  (http://www.holomind.de/phpnet/diff.php) as the basis for his code.
	 *
	 * PHPDiff returns the differences between $old and $new, formatted
	 * in a simple text or html format
	 */
	function PHPDiff($old,$new,$html = false)
	{
		$contextlines = 3;
		$maxbetweendiffs = 10;

	   # split the source text into arrays of lines
	   $t1 = explode("\n",$old);
	   $x=array_pop($t1);
	   if ($x>'') $t1[]="$x\n";
	   $t2 = explode("\n",$new);
	   $x=array_pop($t2);
	   if ($x>'') $t2[]="$x\n";

	   # build a reverse-index array using the line as key and line number as value
	   # don't store blank lines, so they won't be targets of the shortest distance
	   # search
	   foreach($t1 as $i=>$x) if ($x>'') $r1[$x][]=$i;
	   foreach($t2 as $i=>$x) if ($x>'') $r2[$x][]=$i;

	   $a1=0; $a2=0;   # start at beginning of each list
	   $actions=array();

	   # walk this loop until we reach the end of one of the lists
	   while ($a1<count($t1) && $a2<count($t2)) {
	     # if we have a common element, save it and go to the next
	     if ($t1[$a1]==$t2[$a2]) { $actions[]=4; $a1++; $a2++; continue; }

	     # otherwise, find the shortest move (Manhattan-distance) from the
	     # current location
	     $best1=count($t1); $best2=count($t2);
	     $s1=$a1; $s2=$a2;
	     while(($s1+$s2-$a1-$a2) < ($best1+$best2-$a1-$a2)) {
	       $d=-1;
	       foreach((array)@$r1[$t2[$s2]] as $n)
	         if ($n>=$s1) { $d=$n; break; }
	       if ($d>=$s1 && ($d+$s2-$a1-$a2)<($best1+$best2-$a1-$a2))
	         { $best1=$d; $best2=$s2; }
	       $d=-1;
	       foreach((array)@$r2[$t1[$s1]] as $n)
	         if ($n>=$s2) { $d=$n; break; }
	       if ($d>=$s2 && ($s1+$d-$a1-$a2)<($best1+$best2-$a1-$a2))
	         { $best1=$s1; $best2=$d; }
	       $s1++; $s2++;
	     }
	     while ($a1<$best1) { $actions[]=1; $a1++; }  # deleted elements
	     while ($a2<$best2) { $actions[]=2; $a2++; }  # added elements
	  }

	  # we've reached the end of one list, now walk to the end of the other
	  while($a1<count($t1)) { $actions[]=1; $a1++; }  # deleted elements
	  while($a2<count($t2)) { $actions[]=2; $a2++; }  # added elements

	  # and this marks our ending point
	  $actions[]=8;

	  # now, let's follow the path we just took and report the added/deleted
	  # elements into $out.
	  $op = 0;
	  $x0=$x1=0; $y0=$y1=0;
	  $diffout = "";
	  $lastmodifiedline = 0;
	  $firstmod = true;
	  foreach($actions as $act) {
	    if ($act==1) { $op|=$act; $x1++; continue; }
	    if ($act==2) { $op|=$act; $y1++; continue; }
	    if ($op>0) {
	      $xstr = ($x1==($x0+1)) ? $x1 : ($x0+1)."-$x1";
	      $ystr = ($y1==($y0+1)) ? $y1 : ($y0+1)."-$y1";

		  if (! $firstmod) {$diffout .= "\n";}
	      if ($op==1) $diffout .= ($html ? "<span class=\"lines\">" : "### ") . "Line" . (($x1==($x0+1)) ? "" : "s") . " {$xstr} deleted:" . ($html ? "</span>" : "\n");
	      elseif ($op==3) $diffout .= ($html ? "<span class=\"lines\">" : "### ") . "Line" . (($x1==($x0+1)) ? "" : "s") . " {$xstr} changed:" . ($html ? "</span>" : "\n");
	      while ($x0<$x1) { $diffout .= ($html ? "<del>" : "") . '- '. ($html ? htmlentities($t1[$x0]) : $t1[$x0]) . ($html ? "</del>" : "\n"); $x0++; }   # deleted elems
	      if ($op==2) $diffout .= ($html ? "<span class=\"lines\">" : "### ") . "Line" . (($y1==($y0+1)) ? "" : "s") . " {$ystr} added:" . ($html ? "</span>" : "\n");
	      //elseif ($op==3) $diffout .= ($html ? "<span class=\"lines\">" : "## ") . 'To:' . ($html ? "</span>" : "\n");
	      while ($y0<$y1) { $diffout .= ($html ? "<ins>" : "") . '+ '.($html ? htmlentities($t2[$y0]):$t2[$y0]). ($html ? "</ins>" : "\n"); $y0++; }   # added elems

	      $lastmodifiedline = $x1;
	      $firstmod = false;
	    }
	    $x1++; $x0=$x1;
	    $y1++; $y0=$y1;
	    $op=0;
	  }
	  return $diffout;
	}
}
?>
