<?php
/**
 * This Class is for registering users
 *
 * @package Knowledgeroot
 * @author Frank Habermann
 * @version $Id: class-register.php 147 2006-10-26 22:12:45Z koala_s $
 */
class register extends extension_base {

	var $menu = array();

	function main() {
		// load css file for register extension
		$this->CLASS['kr_header']->addcsssrc($this->CONF['cssfile']);

		// add menu item to top navi
		$this->menu['top']['register']['name'] = $this->CLASS['language']->get['ext']['register']['register'];
		$this->menu['top']['register']['link'] = "index.php?action=register";
		$this->menu['top']['register']['priority'] = "1";
		$this->menu['top']['register']['logout'] = "1";

		// check if register form is send
		$do = '';
		if (isset ($_POST['register']) and $_POST['register'] != "") {
			$do = $this->register_user();
		}
		$content = '';
		// check if registerform should be shown
		if (isset ($_GET['action']) and $_GET['action'] == "register" || ($do == 0 && isset ($_POST['register']) and $_POST['register'] != "")) {
			$content = $this->show_register_form($do);
		}

		 return $content;
	}

	function show_register_form($do) {
		$out = "";

		if($_POST['register'] != "" && $do == 0) {
			$fullname = $_POST['fullname'];
			$email = $_POST['email'];
			$email2 = $_POST['email2'];
			$username = $_POST['user'];
		}

		$out .= '
			<div class="registerform">
				<fieldset>
					<legend>' . $this->CLASS['language']->get['ext']['register']['register'] . '</legend>

					<form action="index.php" method="post">
						<div class="registerdescription">
							' . $this->CLASS['language']->get['ext']['register']['description'] . '
						</div>

						<table class="registerform" border="0" cellspacing="0" cellpadding="0" width="300">
							<tr><td>' . $this->CLASS['language']->get['ext']['register']['fullname'] . ': *</td><td class="registerinput"><input type="text" name="fullname" value="' . $fullname . '" size="20"></td></tr>
							<tr><td>' . $this->CLASS['language']->get['ext']['register']['email'] . ': *</td><td class="registerinput"><input type="text" name="email" value="' . $email . '" size="20"></td></tr>
							<tr><td>' . $this->CLASS['language']->get['ext']['register']['confirmemail'] . ': *</td><td class="registerinput"><input type="text" name="email2" value="' . $email2 . '" size="20"></td></tr>
							<tr><td>' . $this->CLASS['language']->get['ext']['register']['username'] . ': *</td><td class="registerinput"><input type="text" name="user" value="' . $username . '" size="20"></td></tr>
							<tr><td>' . $this->CLASS['language']->get['ext']['register']['password'] . ': *</td><td class="registerinput"><input type="password" name="password" value="" size="20"></td></tr>
							<tr><td>' . $this->CLASS['language']->get['ext']['register']['confirmpassword'] . ': *</td><td class="registerinput"><input type="password" name="password2" value="" size="20"></td></tr>
							<tr><td colspan="2" class="registerinput"><input class="button" type="submit" name="register" value="' . $this->CLASS['language']->get['ext']['register']['buttonregister'] . '"></td></tr>
						</table>

					</form>
				</fieldset>
			</div>
		';
		return $out;
	}

	function register_user() {
		if($_POST['user'] != "" && $_POST['password'] != "" && $_POST['password2'] != "" && $_POST['fullname'] != "" && $_POST['email'] != "" && $_POST['email2'] != "") {
			if($_POST['password'] == $_POST['password2'] && $_POST['email'] == $_POST['email2']) {
				// check for password length
				if(strlen($_POST['password']) < $this->CONF['requiredpasswordlength']) {
					$this->CLASS['kr_header']->addwarning($this->CLASS['language']->get['ext']['register']['msgpasswordlength']);
					return 0;
				}

				// check for valid email
				if(!$this->check_email($_POST['email'])) {
					$this->CLASS['kr_header']->addwarning($this->CLASS['language']->get['ext']['register']['msgnovalidemail']);
					return 0;
				}

				// check if user already exists
				$sql = "SELECT id FROM users WHERE name='".$_POST['user']."'";
				$result = $this->CLASS['db']->query($sql);
				$anz = $this->CLASS['db']->num_rows($result);

				if($anz >= 1) {
					$this->CLASS['kr_header']->addwarning($this->CLASS['language']->get['ext']['register']['msguserexists']);
					return 0;
				}

				// create user
				$sql = "INSERT INTO users (fullname, email, name, password, enabled, defaultgroup, defaultrights, admin, rightedit, theme, language) VALUES ('".$_POST['fullname']."', '".$_POST['email']."', '".$_POST['user']."', '".md5($_POST['password'])."', ".$this->CONF['enabled'].", ".$this->CONF['defaultgroup'].", '".$this->CONF['defaultrights']."', ".$this->CONF['admin'].", ".$this->CONF['rightedit'].", '".$this->CONF['theme']."', '".$this->CONF['language']."')";
				$res = $this->CLASS['db']->query($sql);

				$userid = $this->CLASS['db']->last_id("seq_knowledge");

				// join this user to subgroups
				$othergroups = explode(",", $this->CONF['othergroups']);
				if(is_array($othergroups)) {
					foreach($othergroups as $key => $value) {
						$sql = "INSERT INTO user_group (userid, groupid) VALUES (".$userid.", ".$value.")";
						$res1 = $this->CLASS['db']->query($sql);
					}
				}

				if($res) {
					$this->CLASS['kr_header']->addmessage($this->CLASS['language']->get['ext']['register']['msgusercreated']);
					return 1;
				} else {
					$this->CLASS['kr_header']->addwarning($this->CLASS['language']->get['ext']['register']['msgusercreatedfailed']);
					return 0;
				}
			} else {
				if($_POST['password'] != $_POST['password2']) {
					$this->CLASS['kr_header']->addwarning($this->CLASS['language']->get['ext']['register']['msgconfirmpassword']);
				} else {
					$this->CLASS['kr_header']->addwarning($this->CLASS['language']->get['ext']['register']['msgconfirmemail']);
				}

				return 0;
			}
		} else {
			$this->CLASS['kr_header']->addwarning($this->CLASS['language']->get['ext']['register']['msgemptyfields']);
			return 0;
		}
	}

	function check_email($email = "") {
		if(preg_match("/.+@.+\..+/",$email)) {
			return 1;
		} else {
			return 0;
		}
	}
}

?>